#include <math.h>
#include <stdlib.h>

#include "rrt.h"
#include "renderiv.h"
#include "guiplanner.h"
#include "setup.h"
#include "defs.h"
#include "util.h"

int main(int argc, char *argv[])
{
  string path;
  GuiPlanner *gui;
  Model *m = NULL;
  Geom *g = NULL;
  Problem *prob;

  if (argc < 2) {
    cout << "Usage:    " << argv[0] << " <problem path>\n";
    exit(-1);
  }

  path = string(argv[1])+"/";

  if (!is_directory(path)) {
    cout << "Error:   Directory does not exist\n";
    exit(-1);
  }

  SetupProblem(m,g,path);
  
  prob = new Problem(g,m,path);

  gui = new GuiPlanner(new RenderIv(new Scene(prob, path), path),
		       new RRTConCon(prob));

  gui->Start();

  return 0;
}


